/*  miscc -- a compiler for misc
 *    Test application for the semantic analyzer.
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: AnalyzerTest.java,v 1.1 2004/03/01 05:34:23 schinz Exp $
 */

package miscc;

import java.io.*;


/** A small test class for the semantic analyzer of miscc; it reads in a
 *  file and prints out the abstract syntax tree. If the program is
 *  erroneous, the compiler will print a corresponding error message
 *  instead.
 *
 *  usage: java miscc.AnalyzerTest <file.misc>
 */
public class AnalyzerTest {
    public static void main(String[] args) {
        try {
            Parser p = new Parser(new FileInputStream(args[0]));
            new Analyzer().analyze(p.parse());
            p.close();
        } catch (IOException e) {
            Report.fail(e.getMessage());
        }
    }
}
