package miscc;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;

public class GeneratorTest {
    public static void main(String[] args) {
        try {
            InputStream in;
            PrintWriter out;

            if (args.length < 1)
                in = System.in;
            else
                in = new FileInputStream(args[0]);

            if (args.length < 2)
                out = new PrintWriter(System.out);
            else
                out = new PrintWriter(new FileOutputStream(args[1]));

            Parser parser = new Parser(in);
            Tree tree = parser.parse();
            in.close();
            Analyzer analyzer = new Analyzer();
            analyzer.analyze(tree);
            if (Report.errors == 0) {
                Generator generator = new Generator(analyzer.globalScope);
                generator.gen(tree);
                generator.code.write(out);
            }
        } catch (IOException e) {
            Report.fail(e.getMessage());
        }
    }
}
