/*  miscc -- a compiler for misc
 *    Test application for the scanner
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: ScannerTest.java,v 1.1 2004/03/01 05:34:13 schinz Exp $
 */

package miscc;

import java.io.*;


/** A small scanner test class; it reads in a file and prints out
 *  the sequence of tokens.
 *
 *  usage: java miscc.ScannerTest <file.misc>
 */
public class ScannerTest implements Tokens {
    public static void main(String[] args) {
        try {
            Scanner s = new Scanner(new FileInputStream(args[0]));
            while (s.token != EOF) {
                System.out.println(s.representation());
                s.nextToken();
            }
            s.close();
        } catch (IOException e) {
            Report.fail(e.getMessage());
        }
    }
}
