/*  miscc -- a compiler for misc
 *    Symbol table entries.
 *
 *    Matthias Zenger, Michel Schinz, Philippe Altherr
 *    $Id: Symbol.java,v 1.1 2004/03/01 05:34:11 schinz Exp $
 */
package miscc;


/** This class provides a representation for symbol table entries.
 */
class Symbol {

    /** The position of the symbol's definition.
     */
    int pos;

    /** The name of the symbol.
     */
    String name;

    /** The type of the symbol.
     */
    Type type;

    /** Does this symbol refer to a variable?
     */
    boolean isVariable;

    /** Offset of the symbol. For variables, that's the offset
     * relative to the frame pointer, for functions that's the PC of
     * the first instruction.
     */
    int offset;

    /** The next symbol in the scope.
     */
    Symbol next;

    Symbol(int pos, String name, Type type, boolean isVariable) {
        this.pos = pos;
        this.name = name;
        this.type = type;
        this.isVariable = isVariable;
    }

    public String toString() {
        return name + ": " + type;
    }
}
